

#define MUGUI_WID_IMAGE 1
#define MUGUI_WID_TEXT 2


#define	MUGUI_WID_STATUS_SHOW	1
#define	MUGUI_WID_STATUS_HIDE	2


#define MUGUI_WID_TITLEBAR_OTHER	1
#define MUGUI_WID_TITLEBAR_BUTTON_1	2

typedef struct _muGUIChainedText {

	char * text;
	
	void * previous;
	void * next;		


} muGUIChainedText;



typedef struct _muGUIwidget {
	
	unsigned int	ID;
	unsigned char	Type;
	
	int	x;
	int	y;
	unsigned int	w;
	unsigned int	h;
	
	int	previous_x;
	int	previous_y;
	unsigned int	previous_w;
	unsigned int	previous_h;
	
	
	unsigned char	Status;
	unsigned char	NeedRefresh;
	
	char	Title[56];
	
		
	void (*external_draw)( void * this , void * fgui );
	
	void (*internal_draw)( void * this , void * fgui );
	
	int  (*isClick)( void * this , void * fgui , int fx , int fy);
	
	
	/*Image Widget*/
	SDL_Surface * image;
	void (*addImage)( void * this , SDL_Surface * surface );	
	
	
	/*Text Widget*/
	muGUIChainedText *	TextBuffer;
	void (*addText)( void * this , char * ftext );
	unsigned int maxLines;								//to display
	unsigned int displayAtLine;
	

} muGUIwidget;

void muGUIwidget_init ( muGUIwidget * fwid , unsigned char ftype , int fx , int fy , unsigned int fw , unsigned int fh , char * fTitle ) ;

void muGUIwidget_external_draw ( void * this , void * fgui );

void muGUIwidget_default_internal_draw ( void * this , void * fgui );

int muGUIwidget_isClick_TitleBar ( void * this , void * fgui , int fx , int fy);



void muGUIwidget_attachImage ( void * this , SDL_Surface * surface );

void muGUIwidget_image_internal_draw ( void * this , void * fgui ) ;


void muGUIwidget_addText ( void * this , char * ftext ) ;
void muGUIwidget_printAllText ( void * this );
void muGUIwidget_text_internal_draw ( void * this , void * fgui ) ;